summaryrefslogtreecommitdiff
path: root/include
diff options
context:
space:
mode:
Diffstat (limited to 'include')
-rwxr-xr-xinclude/blobutil.sh5
-rwxr-xr-xinclude/mrc.sh82
2 files changed, 85 insertions, 2 deletions
diff --git a/include/blobutil.sh b/include/blobutil.sh
index 182ddf14..b85b8644 100755
--- a/include/blobutil.sh
+++ b/include/blobutil.sh
@@ -10,7 +10,8 @@ appdir="${blobdir}/app"
setvars="EC_url=\"\""
for x in EC_url_bkup EC_hash DL_hash DL_url DL_url_bkup E6400_VGA_DL_hash \
E6400_VGA_DL_url E6400_VGA_DL_url_bkup E6400_VGA_offset E6400_VGA_romname \
- SCH5545EC_DL_url SCH5545EC_DL_url_bkup SCH5545EC_DL_hash; do
+ SCH5545EC_DL_url SCH5545EC_DL_url_bkup SCH5545EC_DL_hash MRC_url \
+ MRC_url_bkup MRC_hash MRC_board; do
setvars="${setvars}; ${x}=\"\""
done
@@ -40,7 +41,7 @@ for x in _me_destination _gbe_destination _ifd_destination \
CONFIG_KBC1126_FW1_OFFSET CONFIG_KBC1126_FW2 CONFIG_KBC1126_FW2_OFFSET \
CONFIG_VGA_BIOS_FILE CONFIG_VGA_BIOS_ID CONFIG_GBE_BIN_PATH \
CONFIG_INCLUDE_SMSC_SCH5545_EC_FW CONFIG_SMSC_SCH5545_EC_FW_FILE \
- CONFIG_IFD_BIN_PATH; do
+ CONFIG_IFD_BIN_PATH CONFIG_MRC_FILE; do
setvars="${setvars}; ${x}=\"\""
done
diff --git a/include/mrc.sh b/include/mrc.sh
new file mode 100755
index 00000000..b9345b92
--- /dev/null
+++ b/include/mrc.sh
@@ -0,0 +1,82 @@
+# SPDX-License-Identifier: GPL-2.0-only
+
+# Logic based on util/chromeos/crosfirmware.sh in coreboot cfc26ce278.
+# Modifications in this version are Copyright 2021 and 2023 Leah Rowe.
+# Original copyright detailed in repo: https://review.coreboot.org/coreboot/
+
+extract_mrc()
+{
+ [ -z "${MRC_board}" ] && err "extract_mrc $MRC_hash: MRC_board not set"
+ [ -z "${CONFIG_MRC_FILE}" ] && \
+ err "extract_mrc $MRC_hash: CONFIG_MRC_FILE not set"
+
+ _file="${MRC_url##*/}"
+ _file="${_file%.zip}"
+ _mrc_destination="${CONFIG_MRC_FILE#../../}"
+ mkdirs "${_mrc_destination}" "extract_mrc" || return 0
+
+ (
+ cd "${appdir}" || err "extract_mrc: !cd ${appdir}"
+ extract_partition ROOT-A "${_file}" root-a.ext2
+ extract_shellball root-a.ext2 chromeos-firmwareupdate-${MRC_board}
+ extract_coreboot chromeos-firmwareupdate-${MRC_board}
+ )
+
+ "${cbfstool}" "${appdir}/"coreboot-*.bin extract -n mrc.bin \
+ -f "${_mrc_destination}" -r RO_SECTION || \
+ err "extract_mrc: could not fetch mrc.bin"
+}
+
+extract_partition()
+{
+ NAME=${1}
+ FILE=${2}
+ ROOTFS=${3}
+ _bs=1024
+
+ printf "Extracting ROOT-A partition\n"
+ ROOTP=$( printf "unit\nB\nprint\nquit\n" | \
+ parted "${FILE}" 2>/dev/null | grep "${NAME}" )
+
+ START=$(( $( echo ${ROOTP} | cut -f2 -d\ | tr -d "B" ) ))
+ SIZE=$(( $( echo ${ROOTP} | cut -f4 -d\ | tr -d "B" ) ))
+
+ dd if="${FILE}" of="${ROOTFS}" bs=${_bs} skip=$(( ${START} / ${_bs} )) \
+ count=$(( ${SIZE} / ${_bs} )) || \
+ err "extract_partition: can't extract root file system"
+}
+
+extract_shellball()
+{
+ ROOTFS=${1}
+ SHELLBALL=${2}
+
+ printf "Extracting chromeos-firmwareupdate\n"
+ printf "cd /usr/sbin\ndump chromeos-firmwareupdate ${SHELLBALL}\nquit" \
+ | debugfs "${ROOTFS}" || err "extract_shellball: debugfs"
+}
+
+extract_coreboot()
+{
+ _shellball=${1}
+ _unpacked=$( mktemp -d )
+
+ printf "Extracting coreboot image\n"
+ [ -f "${_shellball}" ] || \
+ err "extract_coreboot: shellball missing in google cros image"
+ sh "${_shellball}" --unpack "${_unpacked}" || \
+ err "extract_coreboot: shellball exits with non-zero status"
+
+ # TODO: audit the f* out of that shellball, for each mrc version.
+ # it has to be updated for each mrc update. we should ideally
+ # implement the functionality ourselves.
+
+ [ -f "${_unpacked}/VERSION" ] || \
+ err "extract_coreboot: VERSION file missing on google coreboot rom"
+
+ _version=$( cat "${_unpacked}/VERSION" | grep BIOS\ version: | \
+ cut -f2 -d: | tr -d \ )
+
+ cp "${_unpacked}/bios.bin" "coreboot-${_version}.bin" || \
+ err "extract_coreboot: cannot copy google cros rom"
+}